#include "stdafx.h"
#include "HeadlineWrapper.h"

#include <stdlib.h>
#include <string.h>
#include <mbstring.h>

/*----------------------------------------------------------------
	DllMainij
----------------------------------------------------------------*/
BOOL APIENTRY DllMain( HANDLE hModule, DWORD  reason, LPVOID lpReserved)
{
    return TRUE;
}

//wbhCn`
typedef HGLOBAL (__cdecl *HLW_Execute)(HGLOBAL h, long *len);
typedef HGLOBAL (__cdecl *HLW_GetVersion)(long *len);
typedef BOOL    (__cdecl *HLW_Load)(HGLOBAL h, long len);
typedef BOOL    (__cdecl *HLW_Unload)();

static HMODULE g_hModule = NULL;
static HLW_Execute g_pfExecute = NULL;
static HLW_Load g_pfLoad = NULL;
static HLW_Unload g_pfUnload = NULL;
static HLW_GetVersion g_pfGetVersion = NULL;

//[eBeB charnewĕԂ܂
//static char *ConvertToChar(const BSTR &bstr);

/*----------------------------------------------------------------
	ǂݍ݁idllPathwbhCZTDLLj
----------------------------------------------------------------*/
HEADLINEWRAPPER_API int WINAPI load(const char *dllPathIn)
{
	if ( g_hModule ) {
		unload();
	}

	char *dllPath = new char[strlen(dllPathIn) + 1];
	strcpy(dllPath,dllPathIn);
	
	g_hModule = LoadLibrary(dllPath);
	if ( ! g_hModule ) { return FALSE; }

	//牄XGetProcAddresscc
	g_pfExecute = (HLW_Execute)GetProcAddress(g_hModule,"execute");
	if ( ! g_pfExecute ) {
		g_pfExecute = (HLW_Execute)GetProcAddress(g_hModule,"_execute");
	}

	g_pfLoad = (HLW_Load)GetProcAddress(g_hModule,"load");
	if ( ! g_pfLoad ) {
		g_pfLoad = (HLW_Load)GetProcAddress(g_hModule,"_load");
	}

	g_pfUnload = (HLW_Unload)GetProcAddress(g_hModule,"unload");
	if ( ! g_pfUnload ) {
		g_pfUnload = (HLW_Unload)GetProcAddress(g_hModule,"_unload");
	}

	g_pfGetVersion = (HLW_GetVersion)GetProcAddress(g_hModule,"getversion");
	if ( ! g_pfGetVersion ) {
		g_pfGetVersion = (HLW_GetVersion)GetProcAddress(g_hModule,"_getversion");
	}

	if ( ! (g_pfExecute && g_pfLoad && g_pfUnload && g_pfGetVersion) ) {
		delete [] dllPath;
		FreeLibrary(g_hModule);
		g_hModule = NULL;
		return FALSE;
	}

	//tH_擾iŌォobNXbVʒu܂ŃXLj
	char *pPath = (char*)_mbsrchr((unsigned char*)dllPath,'\\');
	if ( ! pPath ) {
		delete [] dllPath;
		FreeLibrary(g_hModule);
		g_hModule = NULL;
		return FALSE;
	}

	//HGLOBALɃRs[
	*(pPath + 1) = 0;
	long len = strlen(dllPath);
	char *pTarget = (char*)GlobalAlloc(GMEM_FIXED,len + 1);
	strcpy(pTarget,dllPath);

	delete [] dllPath;

	g_pfLoad(pTarget,len);

	return TRUE;
}

/*----------------------------------------------------------------
	J
----------------------------------------------------------------*/
HEADLINEWRAPPER_API int WINAPI unload(void)
{
	if ( ! g_hModule ) { return FALSE; }

	g_pfUnload();

	FreeLibrary(g_hModule);
	g_hModule = NULL;

	g_pfExecute = NULL;
	g_pfLoad = NULL;
	g_pfUnload = NULL;
	g_pfGetVersion = NULL;

	return TRUE;
}

/*----------------------------------------------------------------
	sifilePath = HTMLt@Cj
----------------------------------------------------------------*/
HEADLINEWRAPPER_API BSTR WINAPI execute(const char *filePath)
{
	if ( ! g_pfExecute ) {
		return SysAllocStringByteLen("",1);
	}

	long len = strlen(filePath);
	char *pTarget = (char*)GlobalAlloc(GMEM_FIXED,len + 1);
	strcpy(pTarget,filePath);

	HGLOBAL hResult = g_pfExecute(pTarget,&len);
	if ( ! hResult || len <= 0 ) {
		return SysAllocStringByteLen("",1);
	}

	BSTR result = SysAllocStringByteLen((char*)hResult,len);
	GlobalFree(hResult);
	return result;
}

/*----------------------------------------------------------------
	BSTRϊ - sv
----------------------------------------------------------------*/
/*char *ConvertToChar(const BSTR &bstr)
{
	UINT len = SysStringLen(bstr);

	char *pConvTarget = new char[len * 2 + 1]; //ϊ
	if ( ::WideCharToMultiByte(CP_OEMCP,0,bstr,len,pConvTarget,len * 2 + 1,NULL,NULL) ) {
		return pConvTarget;
	}
	else {
		delete [] pConvTarget;
		return NULL;
	}
}*/

